<template>
  <v-container
    id="dashboard"
    fluid
    tag="section"
    white
  >
    <v-row>
      <v-col cols="12" sm="12" md="12" class="pt-5 text-right mb-0 pb-1">
        <v-btn color="success" @click="refesh()"> Refesh</v-btn>
      </v-col>
    </v-row>
    <v-row>
      <v-col
        cols="12"
        lg="12"
        class="mb-0 pb-0"
      >
      <hot-table ref="hotSettingsBugImprove" 
        :settings="hotSettingsBugImprove"> </hot-table>
      </v-col>
      <!-- DON HANG -->
    </v-row>
    <v-overlay :value="overlay">
      <v-progress-circular
        indeterminate
        size="64"
      ></v-progress-circular>
    </v-overlay>
  </v-container>
</template>

<script>
  import axios from 'axios'
  import moment from 'moment'
  import { NumericInput } from 'numeric-keyboard'
  import config from '../../config/config'
  import { HotTable } from "@handsontable-pro/vue";
  import Handsontable from "handsontable";
  // import '~handsontable/dist/handsontable.full.css'
  import "handsontable-pro/dist/handsontable.full.css";
  export default {
    name: 'DashboardDashboard',
    components: {
      HotTable
    },
    data () {
      let self = this;
      return {
        Sheet1: null,
        isTypeIN: false,
        overlay: false,
        hotSettingsBugImprove: {
          copyPaste: true,
          // data: this.pimDATA,
          startRows: 500,
          startCols: 33,
          stretchH: "all",
          autoWrapRow: true,
          height: 765,
          maxRows: 1000,
          rowHeaders: true,
          colHeaders: true,
          filters: true,
          multiColumnSorting: true,
          fixedColumnsLeft: 5,
          columns: [
            {
              //0. No
              width: 50,
              className: "htCenter htMiddle"
            }
            ,{
              //1. EMS No
              width: 80,
              className: "htCenter htMiddle"
            }
            ,{
              //2. Screen
              width: 80,
            }
            ,{
              //3. Area
            }
            ,{
              //4. Need to fix
              width: 450,
            }
            ,{
              //5. Tester
            }
            ,{
              //6. Test date
              width: 90,
              className: "htCenter htMiddle"
            }
            ,{
              //7. PIC
              width: 100,
              className: "htCenter htMiddle"
            }
            ,{
              //8. Fixed date
              width: 90,
              className: "htCenter htMiddle"
            }
            ,{
              //9. Test AWS
              width: 70,
              className: "htCenter htMiddle"
            }
            ,{
              //10. EMS Ticket No.
            }
            ,{
              //11. Addditions Notes.
              width: 230,
            }
            ,{
              //12. Process
              width: 80,
              className: "htCenter htMiddle"
            }
            ,{
              //13. PIC Dev
              width: 120,
              className: "htCenter htMiddle"
            }
            ,{
              //14. PIC Test
              width: 120,
              className: "htCenter htMiddle"
            }
            ,{
              //15. EST Dev & Test
            }
            ,{
               //16. EST Dev & Test
            }
            ,{
               //17. EST Dev & Test
            }
            ,{
               //18. Act Fishisned date
            }
            ,{
              //19. Task Type
              width: 100,
              className: "htCenter htMiddle"
            }
            ,{
              //20. Est Dev (H)
              width: 60,
              className: "htCenter htMiddle modDevelop"
            }
            ,{//21. Est Test (H)
              width: 60,
              className: "htCenter htMiddle modDevelop"}
            ,{
              //22. Est Total (H)
              width: 60,
              className: "htCenter htMiddle modDevelop"
            }
            ,{
              //23. Plan start
              width: 110,
              className: "htCenter htMiddle modPlan",
              type: 'date',
              dateFormat: 'YYYY-MM-DD',
              correctFormat: true,
            }
            ,{
              //24. Plan End
              width: 110,
              className: "htCenter htMiddle modPlan",
              type: 'date',
              dateFormat: 'YYYY-MM-DD',
              correctFormat: true,
            }
            ,{
              //25. EMS_SUB
            }
            ,{
              //26.COMMENT_CLV
              width: 230,
            }
            ,{
              //27. BRANCH
              width: 120,
              className: "htCenter htMiddle modSRC"
            }
            ,{
              //28. Module
              width: 120,
              className: "htCenter htMiddle modSRC"
            }
            ,{
              //29. Status SRC
              width: 120,
              className: "htCenter htMiddle modSRC"
            }
          ],
          colHeaders: [
            "No."
            ,"EMS No."	
            ,"Screen"	
            ,"Area"
            ,"Need To Fix"	
            ,"Tester"	
            ,"Test Date"
            ,"PIC"
            ,"Fixed Date"
            ,"Test AWS"	
            ,"EMS Ticket No."	
            ,"Additional Notes" 	
            ,"Process"	
            ,"PIC DEV"	
            ,"PIC Test"
            ,"Est Dev & Test"
            ,"Est Task BP"
            ,"Act Start Date"
            ,"Act Finish Date"
            ,"Task Type"
            ,"Est Dev Hour"
            ,"Est Test Hour"
            ,"Est Total Hour"
            ,"Plan Start Date"
            ,"Plan Finish Date"	
            ,"EMS_SUB"	
            ,"COMMENT CLV"	
            ,"BRANCH"	
            ,"Module"
            ,"Status SRC"
          ],
          hiddenColumns: {
            columns: [3, 5, 10, 15, 16, 17, 18, 25],
            // indicators: true
          },
          multiColumnSorting: {
            sortEmptyCells: true,
            initialConfig: [ {
              column: 12,
              sortOrder: 'desc'
            }]
          },
          contextMenu: true,
          dropdownMenu: ['filter_by_condition', 'filter_action_bar', 'filter_by_value'],
          language: "en-US",
          afterChange: () => {},
          // cell: [
          //   {row: 1, col: 19, renderer: self.greenRenderer}
          // ],
          cells: function(row, col) {
            if (col == 1 || col === 19) {
              // self.isTypeIN = true;
              this.renderer = self.taskTypeRender;
            }
            if (col === 0 || col === 29) {
              this.renderer = self.stsSRCRender;
            }
          },
          // afterOnCellMouseDown: function () {
            //   var cell = this;
            //   console.log('value', cell.getValue());
            //   let selected = cell.getSelected();
            //   if(selected != undefined && selected[0][1] == 15){
            //     let data = cell.getData();
            //     let jiraID = cell.getValue();
            //     self.getWorklogByTicketOfline(data, jiraID);
            //   }
            // }
          

        },
      }
    },
    computed: {
      
    },
    mounted () {},
    created () {
      // this.refesh();
    
     
    },
    methods: {
      taskTypeRender(instance, td, row, col, prop, value, cellProperties) {
        Handsontable.renderers.TextRenderer.apply(this, arguments);
        if(col === 19){
          if('IN' === value){
            td.style.color = 'red';
            td.className = 'htCenter htMiddle';
          }
        }else if(col == 1){
          let dataSRC = instance.getDataAtCell(row,19);
          if('IN' === dataSRC){
            td.style.color = 'red';
            td.className = 'htCenter htMiddle';
          }
        }
        
      },
      stsSRCRender(instance, td, row, col, prop, value, cellProperties) {
        Handsontable.renderers.TextRenderer.apply(this, arguments);
          if(col === 29){
            if('Merge 15' === value){
              td.style.background = 'Yellow';
              td.className = 'htCenter htMiddle';
            }
          }else if(col === 0){
            let dataSRC = instance.getDataAtCell(row,29);
            console.log("valueinstance.getDataAtCell(row,29)", instance.getDataAtCell(row,29));
            switch(dataSRC){
              case 'Request':
                td.style.background = 'Yellow';
                td.className = 'htCenter htMiddle';
                break;
              case 'Request Push':
                td.style.background = 'Orange';
                td.className = 'htCenter htMiddle';
                break;
            }
            
          }
      },
      async refesh (){
        let self = this;
        let sheet = config.sheetDashboardConfig

        // SOG_SHEET
        // 1ryx_G4snRvZKoV2KEJJY2vhHoaghzS4Nq9cnul_n9vw
        let SOG_sheet = config.sheetDashboardConfig;
        //178Yznh4Kl7DMQBCCy9dbWcedCVXF_NLQ1UjB3GCAZ1c
        self.overlay = true;
        await axios
          .post(`${config.API_JIRA}/api/readSheet`, sheet)
          .then(async function (response) {
            var seriArr = [];
            var seriLabel = [];
            var data = response.data.data;
            let bug_improvement_processing = data.filter(function (item) {
              if (item.sheetName == 'Bug & Improvement') return true
            })
            // self.Sheet1 = bug_improvement[0];
            //Only processing
            bug_improvement_processing = bug_improvement_processing[0].sheetData;
            // bug_improvement_processing = bug_improvement_processing[0].sheetData.filter(function (item) {
            //   if (item[12] != 'Finished' && item[12] != 'No Bug') return true
            // })
            await self.$refs.hotSettingsBugImprove.hotInstance.loadData(bug_improvement_processing);
            self.overlay = false;
            console.log("bug_improvement_processing", bug_improvement_processing);
        });
      }
    },
  }
</script>
<style>
  .modDevelop{
    background-color: lightcyan  !important;
  }

  .modPlan{
    color: cornflowerblue;
    /* font-weight: bold; */
  }
  .modSRC{
    color: darkgreen;
  }
  .spotlight {
    background-color: red  !important;;
  }

  .v-overlay--active{
    z-index: 9999 !important;
  }
  
</style>
